//Fonction rotation figure autours d'un point déf' axe vertical
module rotate_about_pt(a, v, pt) 
    {
        translate(pt) rotate(a,v) translate(-pt) children();   
    }
//Fonction rotation figure autours d'un point déf' axe horizontale
module rotate_about_pt_2(a, v, pt) 
    {
        translate(pt) rotate([v,a,0]) translate(-pt) children();   
    }   


module fentes_moteur()
    {
        $fn = 20;
        translate([6.65+13.65-5.5,0,27]) hull () 
            {
                translate([0,0,0]) cylinder(r=3,h=6);
                translate([8,-9.5/2,0]) cylinder(r=0.1,h=6);
                translate([8,9.5/2,0]) cylinder(r=0.1,h=6);
            }
        translate([22.5+0.3,-4.75-0.1,27]) cube([2,9.7,6]); 
           
        rotate_about_pt(90,0,[0,0,0])
            {
                $fn = 20;
                translate([6.65+13.65-5.5,0,27]) hull () 
                    {
                        translate([0,0,0]) cylinder(r=3,h=6);
                        translate([8,-9.5/2,0]) cylinder(r=0.1,h=6);
                        translate([8,9.5/2,0]) cylinder(r=0.1,h=6);
                    }
                translate([22.5+0.3,-4.75-0.1,27]) cube([2,9.7,6]); 
            }
        rotate_about_pt(90+45,0,[0,0,0])
            {
                $fn = 20;
                translate([6.65+13.65-5.5,0,27]) hull () 
                    {
                        translate([0,0,0]) cylinder(r=3,h=6);
                        translate([8,-9.5/2,0]) cylinder(r=0.1,h=6);
                        translate([8,9.5/2,0]) cylinder(r=0.1,h=6);
                    }
                translate([22.5+0.3,-4.75-0.1,27]) cube([2,9.7,6]); 
            }
            
        rotate_about_pt(180,0,[0,0,0])
            {
                $fn = 20;
                translate([6.65+13.65-5.5,0,27]) hull () 
                    {
                        translate([0,0,0]) cylinder(r=3,h=6);
                        translate([8,-9.5/2,0]) cylinder(r=0.1,h=6);
                        translate([8,9.5/2,0]) cylinder(r=0.1,h=6);
                    }
                translate([22.5+0.3,-4.75-0.1,27]) cube([2,9.7,6]); 
            }
        rotate_about_pt(180+45,0,[0,0,0])
            {
                $fn = 20;
                translate([6.65+13.65-5.5,0,27]) hull () 
                    {
                        translate([0,0,0]) cylinder(r=3,h=6);
                        translate([8,-9.5/2,0]) cylinder(r=0.1,h=6);
                        translate([8,9.5/2,0]) cylinder(r=0.1,h=6);
                    }
                translate([22.5+0.3,-4.75-0.1,27]) cube([2,9.7,6]); 
            }

        rotate_about_pt(-90,0,[0,0,0])
            {
                $fn = 20;
                translate([6.65+13.65-5.5,0,27]) hull () 
                    {
                        translate([0,0,0]) cylinder(r=3,h=6);
                        translate([8,-9.5/2,0]) cylinder(r=0.1,h=6);
                        translate([8,9.5/2,0]) cylinder(r=0.1,h=6);
                    }
                translate([22.5+0.3,-4.75-0.1,27]) cube([2,9.7,6]); 
            }
        rotate_about_pt(-90+45,0,[0,0,0])
            {
                $fn = 20;
                translate([6.65+13.65-5.5,0,27]) hull () 
                    {
                        translate([0,0,0]) cylinder(r=3,h=6);
                        translate([8,-9.5/2,0]) cylinder(r=0.1,h=6);
                        translate([8,9.5/2,0]) cylinder(r=0.1,h=6);
                    }
                translate([22.5+0.3,-4.75-0.1,27]) cube([2,9.7,6]); 
            }
        rotate_about_pt(-90+45+90,0,[0,0,0])
            {
                $fn = 20;
                translate([6.65+13.65-5.5,0,27]) hull () 
                    {
                        translate([0,0,0]) cylinder(r=3,h=6);
                        translate([8,-9.5/2,0]) cylinder(r=0.1,h=6);
                        translate([8,9.5/2,0]) cylinder(r=0.1,h=6);
                    }
                translate([22.5+0.3,-4.75-0.1,27]) cube([2,9.7,6]); 
            }   
    }



//Support d'acroche du moteur, coupelle du haut
difference()
    {
        translate([0,0,12+11+0.5]) cylinder(h=3.5, r1=15, r2=46.6/2, $fn=100, center=false);
        translate([0,0,-5]) fentes_moteur();   
        // Trous de vis
        translate([0,6.65+0.5,3]) linear_extrude(height = 30)scale([1,1,1])circle(d=3,$fn=100);
        translate([6.65+0.5,0,3]) linear_extrude(height = 30)scale([1,1,1])circle(d=3,$fn=100);
        translate([0,-6.65-0.5,3]) linear_extrude(height = 30)scale([1,1,1])circle(d=3,$fn=100);
        translate([-6.65-0.5,0,3]) linear_extrude(height = 30)scale([1,1,1])circle(d=3,$fn=100);
        // Trous de tête de vis
        translate([0,6.65+0.5,27.31-1-10]) linear_extrude(height = 20)scale([1,1,1])circle(d=5,$fn=100);
        translate([6.65+0.5,0,27.31-1-10]) linear_extrude(height = 20)scale([1,1,1])circle(d=5,$fn=100);
        translate([0,-6.65-0.5,27.31-1-10]) linear_extrude(height = 20)scale([1,1,1])circle(d=5,$fn=100);
        translate([-6.65-0.5,0,27.31-1-10]) linear_extrude(height = 20)scale([1,1,1])circle(d=5,$fn=100);    
    }

//Support d'acroche du moteur, bas
difference()
    {
        translate([0,0,27]) linear_extrude(height = 4.5)scale([1,1,1])circle(d=46.6,$fn=100);
        //#translate([0,0,31.51]) cylinder(h=1.5, r1=38.6/2, r2=46.6/2, $fn=100);

        // Trous de vis
        translate([0,6.65+0.5,3]) linear_extrude(height = 30)scale([1,1,1])circle(d=3,$fn=100);
        translate([6.65+0.5,0,3]) linear_extrude(height = 30)scale([1,1,1])circle(d=3,$fn=100);
        translate([0,-6.65-0.5,3]) linear_extrude(height = 30)scale([1,1,1])circle(d=3,$fn=100);
        translate([-6.65-0.5,0,3]) linear_extrude(height = 30)scale([1,1,1])circle(d=3,$fn=100);
        // Trous de tête de vis
        translate([0,6.65+0.5,27.31-1]) linear_extrude(height = 2)scale([1,1,1])circle(d=5,$fn=100);
        translate([6.65+0.5,0,27.31-1]) linear_extrude(height = 2)scale([1,1,1])circle(d=5,$fn=100);
        translate([0,-6.65-0.5,27.31-1]) linear_extrude(height = 2)scale([1,1,1])circle(d=5,$fn=100);
        translate([-6.65-0.5,0,27.31-1]) linear_extrude(height = 2)scale([1,1,1])circle(d=5,$fn=100);
           
        fentes_moteur();
    }


//Bras
difference()
    {
        translate([0,-46.6/2,23.5]) cube([60-25,46.6,8]);
        
        //trous Charniére
        translate([60-25,+0.5,23.5]) rotate ([90,0,0]) cylinder(r=8.5,h=46.6/2+1.1, $fn=100); 
        translate([60-25,46.6/2+2,23.5]) rotate ([90,0,0]) cylinder(r=4.5/2,h=50, $fn=100); 
        translate([60-25,30,23.5]) rotate ([90,0,0]) cylinder(r=8.52/2,h=20, $fn=6);
        
        //Finitions arrondies
        translate([0,38.2,50.5]) rotate([0,180,0]) translate([0,0,12+11+0.5]) cylinder(h=3.5, r1=15, r2=46.6/2, $fn=100, center=false);
        translate([0,-38.2,50.5]) rotate([0,180,0]) translate([0,0,12+11+0.5]) cylinder(h=3.5, r1=15, r2=46.6/2, $fn=100, center=false);

        // Trous de vis
        translate([0,6.65+0.5,3]) linear_extrude(height = 30)scale([1,1,1])circle(d=3,$fn=100);
        translate([6.65+0.5,0,3]) linear_extrude(height = 30)scale([1,1,1])circle(d=3,$fn=100);
        translate([0,-6.65-0.5,3]) linear_extrude(height = 30)scale([1,1,1])circle(d=3,$fn=100);
        translate([-6.65-0.5,0,3]) linear_extrude(height = 30)scale([1,1,1])circle(d=3,$fn=100);
        
        // Trous de tête de vis
        translate([0,6.65+0.5,27.31-1-10]) linear_extrude(height = 20)scale([1,1,1])circle(d=5,$fn=100);
        translate([6.65+0.5,0,27.31-1-10]) linear_extrude(height = 20)scale([1,1,1])circle(d=5,$fn=100);
        translate([0,-6.65-0.5,27.31-1-10]) linear_extrude(height = 20)scale([1,1,1])circle(d=5,$fn=100);
        translate([-6.65-0.5,0,27.31-1-10]) linear_extrude(height = 20)scale([1,1,1])circle(d=5,$fn=100);  

        fentes_moteur(); 
        translate([0,0,-5]) fentes_moteur();       
    }
    
//Support de l'écrou    
difference()
    {
        translate([60-25,46.6/2,23.5]) rotate ([90,0,0]) cylinder(r=8,h=46.6/2-0.5, $fn=100);
        translate([60-25,46.6/2+2,23.5]) rotate ([90,0,0]) cylinder(r=4.5/2,h=50, $fn=100);       
        translate([60-25,30,23.5]) rotate ([90,0,0]) cylinder(r=8.52/2,h=20, $fn=6);    
    }

//Crans d'arrêt
translate([-25,0,0])
    {
        translate([60,0.5,27.5]) rotate ([0,0,0]) cylinder(r=0.5,h=3, $fn=100);
        rotate_about_pt_2(30,0,[60,0.5,23.5])translate([60,0.5,27.5]) rotate ([0,0,0]) cylinder(r=0.5,h=3, $fn=100);      
        rotate_about_pt_2(60,0,[60,0.5,23.5])translate([60,0.5,27.5]) rotate ([0,0,0]) cylinder(r=0.5,h=3, $fn=100);
        rotate_about_pt_2(90,0,[60,0.5,23.5])translate([60,0.5,27.5]) rotate ([0,0,0]) cylinder(r=0.5,h=3, $fn=100);
        rotate_about_pt_2(120,0,[60,0.5,23.5])translate([60,0.5,27.5]) rotate ([0,0,0]) cylinder(r=0.5,h=3, $fn=100);          
        rotate_about_pt_2(150,0,[60,0.5,23.5])translate([60,0.5,27.5]) rotate ([0,0,0]) cylinder(r=0.5,h=3, $fn=100);
        rotate_about_pt_2(180,0,[60,0.5,23.5])translate([60,0.5,27.5]) rotate ([0,0,0]) cylinder(r=0.5,h=3, $fn=100);
        rotate_about_pt_2(210,0,[60,0.5,23.5])translate([60,0.5,27.5]) rotate ([0,0,0]) cylinder(r=0.5,h=3, $fn=100);          
        rotate_about_pt_2(240,0,[60,0.5,23.5])translate([60,0.5,27.5]) rotate ([0,0,0]) cylinder(r=0.5,h=3, $fn=100);
        rotate_about_pt_2(270,0,[60,0.5,23.5])translate([60,0.5,27.5]) rotate ([0,0,0]) cylinder(r=0.5,h=3, $fn=100);
        rotate_about_pt_2(300,0,[60,0.5,23.5])translate([60,0.5,27.5]) rotate ([0,0,0]) cylinder(r=0.5,h=3, $fn=100);          
        rotate_about_pt_2(330,0,[60,0.5,23.5])translate([60,0.5,27.5]) rotate ([0,0,0]) cylinder(r=0.5,h=3, $fn=100);
    }